
Installer - Feature #36437

configure pulpcore gunicorn with --preload

05/25/2023 06:53 AM - Evgeni Golov

Status: Closed   

Priority: Normal   

Assignee: Evgeni Golov   

Category: Foreman modules   

Target version:    

Difficulty:  Fixed in Releases: 3.7.0

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/puppet-pul

pcore/pull/288

  

Description

We did some testing and found that adding the --preload flag to the gunicorn execution command line for the

pulpcore-content/pulpcore-api service reduces the memory overhead required by several hundred megabytes, because it is able to

share more memory pages, and several copies of the pulpcore-content worker processes are active resulting in compounded gains

with higher numbers of workers.

https://discourse.pulpproject.org/t/api-server-memory-leak/851/3

The primary downside is not relevant to the Katello use case.

(originally submitted in https://github.com/theforeman/puppet-pulpcore/issues/286, moved here for better tracking)

Associated revisions

Revision b8189466 - 05/25/2023 09:19 AM - Evgeni Golov

Fixes #36437 - preload pulpcore API and content code

this reduces the overall memory usage by keeping only one copy of the

code, instead of N (= number of workers).

unscientific benchmark says that with 5 API and 17 content workers, this

reduces the memory footprint from 500MiB to 125MiB and from 1.5GiB to

500MiB respectively.

those numbers are obviously before any actual work is executed and

memory consumed by the app itself.

History

#1 - 05/25/2023 06:59 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/puppet-pulpcore/pull/288 added

#2 - 05/25/2023 07:06 AM - Evgeni Golov

- Description updated

- Category deleted (Foreman modules)

#3 - 05/25/2023 07:06 AM - Evgeni Golov

- Category set to Foreman modules

#4 - 05/25/2023 09:19 AM - The Foreman Bot

- Fixed in Releases 3.8.0 added

#5 - 05/25/2023 10:00 AM - Evgeni Golov
https://discourse.pulpproject.org/t/api-server-memory-leak/851/3
https://github.com/theforeman/puppet-pulpcore/issues/286


- Status changed from Ready For Testing to Closed

Applied in changeset puppet-pulpcore|b8189466629b05df91fe90fbb7f741e2e9c27786.

#6 - 05/30/2023 01:59 PM - Evgeni Golov

- Fixed in Releases 3.7.0 added

- Fixed in Releases deleted (3.8.0)
